//
//  ViewController.m
//  左右滑动切换
//
//  Created by linjiangfeng on 2018/5/9.
//  Copyright © 2018年 发哥. All rights reserved.
//

#import "ViewController.h"

#import "UIView+Extension.h"
#import "NSArray+Extension.h"

//**********************  设备的 宽高 ******************************//
// 设备全屏高
#define SCREEN_FULL_HEIGHT  [[UIScreen mainScreen] bounds].size.height
// 设备全屏宽
#define SCREEN_FULL_WIDTH [[UIScreen mainScreen] bounds].size.width

//按钮间的间隔
int interval = 25;

//滑块的宽度
int sliderWidth = 24;

//按钮的宽度
int buttonWidth = 60;

@interface ViewController ()<UIScrollViewDelegate>
{
    NSArray *_arrTitles;
    
    int _selectIndex;
    
    int _lastContentOffset;
    
    UIButton *_btnLeft;
    UIButton *_btnRight;
    
}
@property (strong, nonatomic) UIScrollView *scrollView;
@property (strong, nonatomic) UIScrollView *scrollViewNavi;
@property (strong, nonatomic) UIView *viewSlider;

@property (strong, nonatomic) NSMutableArray  *arrBtns;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.view.backgroundColor = [UIColor colorWithWhite:0.9 alpha:1];
    
    //初始化 顶部按钮的ScrollView
    [self initNavi];
    
    //初始化 内容的ScrollView
    [self initViews];
    // Do any additional setup after loading the view, typically from a nib.
}

//初始化 顶部按钮的ScrollView
-(void)initNavi
{
    _arrTitles = @[@"热门",@"综艺",@"电视剧",@"电影",@"动漫",@"儿童",];
    
    self.arrBtns = [NSMutableArray array];
    
    UIView *viewNavigation = [[UIView alloc]initWithFrame:CGRectMake(0, 0, SCREEN_FULL_WIDTH, 64)];
    viewNavigation.backgroundColor = [UIColor whiteColor];
    [self.view addSubview:viewNavigation];
    
    
    UIScrollView *scrollrView = [[UIScrollView alloc]initWithFrame:viewNavigation.bounds];
    scrollrView.tag = 0;
    self.scrollViewNavi = scrollrView;
    [viewNavigation addSubview:scrollrView];
    
    _selectIndex = 0;
    
    
    int minX = 40;
    
    for (int i=0; i<_arrTitles.count; i++) {
        //顶部按钮
        UIButton *button = [[UIButton alloc]initWithFrame:CGRectMake(minX , 30, buttonWidth, 33)];
        button.tag = i;
        [button addTarget:self action:@selector(screenBtnTouchEvent:) forControlEvents:UIControlEventTouchUpInside];
        [button setTitle:_arrTitles[i] forState:UIControlStateNormal];
        [button setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
        
        [scrollrView addSubview:button];
        
        
        if (i==0) {
            //滑块
            UIView *viewSlider = [[UIView alloc]initWithFrame:CGRectMake(0, 60, sliderWidth, 2)];
            viewSlider.backgroundColor = [UIColor redColor];
            viewSlider.center = CGPointMake(button.center.x, viewSlider.center.y);
            viewSlider.layer.cornerRadius = 1;
            viewSlider.layer.masksToBounds = YES;
            self.viewSlider = viewSlider;
            [scrollrView addSubview:viewSlider];
            
            _btnLeft = button;
            button.titleLabel.font = [UIFont systemFontOfSize:19];
            
            [button setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
        }else
        {
            if (i==1)
            {
                _btnRight = button;
            }
            button.titleLabel.font = [UIFont systemFontOfSize:16];
            
            [button setTitleColor:[UIColor colorWithWhite:0.5 alpha:1] forState:UIControlStateNormal];
        }
        [self.arrBtns addObject:button];
        
        minX += buttonWidth+interval;
    }
    
    scrollrView.contentSize = CGSizeMake(minX-12, 0);
    
}
//初始化 内容的ScrollView
-(void)initViews
{
    int navigationHeight = 64;
    
    UIScrollView *scrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, navigationHeight, SCREEN_FULL_WIDTH, SCREEN_FULL_HEIGHT-navigationHeight)];
    scrollView.tag = 1;
    scrollView.showsHorizontalScrollIndicator = NO;
    scrollView.delegate = self;
    scrollView.bounces = NO;
    self.scrollView = scrollView;
    [self.view addSubview:scrollView];

    
    for (int i=0; i<self.arrBtns.count; i++) {
        
        int xr = 1+arc4random() % 256;
        int xg = 1+arc4random() % 256;
        int xb = 1+arc4random() % 256;
        //放内容的View
        UIView *view = [[UIView alloc]initWithFrame:CGRectMake(i*SCREEN_FULL_WIDTH, 0, SCREEN_FULL_WIDTH, SCREEN_FULL_HEIGHT-64)];
        view.backgroundColor = [UIColor colorWithRed:xr*1.0/255 green:xg*1.0/255 blue:xb*1.0/255 alpha:1];
        [scrollView addSubview:view];
    }
    
    scrollView.pagingEnabled = YES;
    scrollView.contentSize = CGSizeMake(SCREEN_FULL_WIDTH*self.arrBtns.count, 0);
}

-(void)scrollViewWillEndDragging:(UIScrollView *)scrollView withVelocity:(CGPoint)velocity targetContentOffset:(inout CGPoint *)targetContentOffset
{
    if (scrollView.tag == 0) {
        
    }else
    {
        int index = (int)(targetContentOffset->x / SCREEN_FULL_WIDTH);
        
        [self selectButtonWithIndex:index];
    }
    
}

//实现scrollView代理
- (void)scrollViewWillBeginDragging:(UIScrollView *)scrollView{
    
    if (scrollView.tag == 0) {
        
    }else
    {
        //全局变量记录滑动前的contentOffset
        _lastContentOffset = scrollView.contentOffset.x;//判断左右滑动时
    }
    
    
}


- (void)scrollViewDidScroll:(UIScrollView *)scrollView{
    
    if (scrollView.tag == 0) {
        
    }else
    {
        int screenWidth = SCREEN_FULL_WIDTH/2;
        
        int contentOffsetX = scrollView.contentOffset.x;
        
        
        int sWidth =  SCREEN_FULL_WIDTH;
        int content_X = (contentOffsetX % (sWidth));
        
        int selectIndex = contentOffsetX/sWidth;
        
        float scale =  0;
        
        if (contentOffsetX>0 && contentOffsetX<=sWidth*self.arrBtns.count) {
            
            //判断左右滑动时
            if (contentOffsetX < _lastContentOffset ){
                
                selectIndex = selectIndex+1;
                
                //向左
                _btnRight = [self.arrBtns safeObjectAtIndex:selectIndex];
                _btnLeft = [self.arrBtns safeObjectAtIndex:selectIndex-1];
                
                
            } else if (scrollView. contentOffset.x > _lastContentOffset ){
                //向右
                _btnRight = [self.arrBtns safeObjectAtIndex:selectIndex+1];
                _btnLeft = [self.arrBtns safeObjectAtIndex:selectIndex];
                
            }
            
            
            if (content_X < SCREEN_FULL_WIDTH/2 ) {
                
                scale = content_X*1.0/screenWidth;
                
                self.viewSlider.origin_x = _btnLeft.center.x-(sliderWidth/2) + scale*(sliderWidth/2);
                self.viewSlider.size_width = sliderWidth + (interval+buttonWidth-sliderWidth) * scale;
                
                
                
            }else if(content_X >= SCREEN_FULL_WIDTH/2 )
            {
                scale = (content_X-screenWidth)*1.0/screenWidth;
//                scale = scale==0?1:scale;
                
                self.viewSlider.origin_x = _btnLeft.center.x +  scale*((_btnRight.center.x - _btnLeft.center.x)-sliderWidth/2);
                
                self.viewSlider.size_width = _btnRight.center.x-self.viewSlider.origin_x+(sliderWidth/2*scale);
                
            }
            
            NSLog(@"scale = %f",scale);
            
            
            
        }
    }
    
    
}

-(void)screenBtnTouchEvent:(UIButton *)btn
{
    NSInteger index = btn.tag;
    
    [self selectButtonWithIndex:(int)index];
}

-(void)selectButtonWithIndex:(int)index
{
    //原来的按钮
    UIButton *btnOir = [_arrBtns safeObjectAtIndex:_selectIndex];
    //最新的按钮
    UIButton *btnNew = [_arrBtns safeObjectAtIndex:index];

    self.viewSlider.center = CGPointMake(btnNew.center.x, self.viewSlider.center.y);
    
    //改变字体大小 和 字体颜色
    [btnOir setTitleColor:[UIColor colorWithWhite:0.5 alpha:1] forState:UIControlStateNormal];
    [btnNew setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
    btnOir.titleLabel.font = [UIFont systemFontOfSize:16];
    btnNew.titleLabel.font = [UIFont systemFontOfSize:19];
    
    //最新按钮的中心点 - 二分之一的屏幕宽度
    int minx = btnNew.center.x-(SCREEN_FULL_WIDTH/2);
    
    //滑到最后的X坐标
    int maxX = self.scrollViewNavi.contentSize.width-SCREEN_FULL_WIDTH;
    
    if (minx > 0 && minx < maxX )
    {//最新按钮的中心点 大于 半屏  且 self.scrollViewNavi.contentSize.width > 屏幕宽度
        
        //self.scrollViewNavi 往右滑动 minx = btnNew.center.x 离 屏幕中心点距离
        [UIView animateWithDuration:0.3 animations:^{
            self.scrollViewNavi.contentOffset = CGPointMake(minx, 0);
        }];
        
    }else if (minx <= 0)
    {//最新按钮的中心点在最前面  没超过屏幕中心点
        
        //直接滑到最前面
        [UIView animateWithDuration:0.3 animations:^{
            self.scrollViewNavi.contentOffset = CGPointMake(0, 0);
        }];
    }else if (minx >= maxX)
    {//最新按钮的中心点在最后面 超过屏幕中心点
        
        //直接滑到最后
        [UIView animateWithDuration:0.3 animations:^{
            self.scrollViewNavi.contentOffset = CGPointMake(self.scrollViewNavi.contentSize.width-SCREEN_FULL_WIDTH, 0);
        }];
    }
    
    _selectIndex = index;
    
    
    [self.scrollView setContentOffset:CGPointMake(index*SCREEN_FULL_WIDTH, 0) animated:YES];
    
}



- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
